# kernel

### APPLICATION

kernel

### APPLICATION SUMMARY

The Kernel Application

### DESCRIPTION

The Kernel application is the first application started, and it is one of two mandatory applications. The Kernel application contains the following services:

- `application_controller`
- `auth`
- `code`
- `disk_log`
- `erl_boot_server`
- `erl_ddll`
- `error_logger`
- `file`
- `global_group`
- `global_name_server`
- `net_kernel`
- `os`
- `rpc`
- `pg2`
- `timer`
- `user`

It is possible to synchronize a set of Erlang nodes. One can specify for a node to wait a specified amount of time for other nodes to become alive.

### Error Logger Event Handlers

Two error logger event handlers are defined in the Kernel application. These are described in `error_logger(3)`.

### Configuration

The following configuration parameters are defined for the Kernel application. See application(3) for more information about configuration parameters.

`distributed = [Distrib] <optional>`
  Specifies which applications are distributed and on which nodes they may execute. In this parameter:
  - `Distrib = {ApplName, Nodes} | {ApplName, Time, Nodes}`
  - `ApplName = atom()`
  - `Time = integer() > 0`
  - `Nodes = [node() | {node(), ..., node()}]`
  These parameters are described in application(3).
`dist_auto_connect = Value <optional>`
  Specifies when nodes will be automatically connected. If this parameter is not specified, a node is always automatically connected, e.g when a message is to be sent to that node. `Value` is one of:
  `never`
    Connections are never automatically connected, they must be explicitly connected. See net_kernel(3).
  `once`
    Connections will be established automatically, but only once per node. If a node goes down, it must thereafter be explicitly connected. See net_kernel(3).
`permissions = [Perm] <optional>`
  Specifies the default permission for applications when they are started. In this parameter:
  - `Perm = {ApplName, Bool}`
  - `ApplName = atom()`
  - `Bool = boolean()`
`error_logger = Value <optional>`
  `Value` is one of:
  `tty`
    All standard error reports are written to `stdio`. This is the default option.
  `{file, FileName}`
    All standard error reports are written to the file `FileName`, where `FileName` is a string.
  `false`
    No error logger handler is installed.
`global_groups = [GroupTuple] <optional>`
  Specifies the groups of nodes which will have their own global name space. In this parameter:
  - `GroupTuple = {GroupName, [Node]} | {GroupName, PublishType, [Node]}`
  - `GroupName = atom()`
  - `PublishType = atom()`
  - `Node = atom()`
  These parameters are described in global_group(3).
`inet_parse_error_log = LogMode <optional>`
  `LogMode` is one of:
  `silent`
    No `error_logger` messages are generated when erroneous lines are found and skipped in the various configuration files. The default if the variable is not set is that erroneous lines are reported via the `error_logger`.
`net_ticktime = TickTime <optional>`
  Specifies the `net_kernel` tick time. `TickTime` is given in seconds. Once every `TickTime / 4` second, all connected nodes are ticked (if anything else has been written to a node) and if nothing has been received from another node within the last four (4) tick times that node is considered to be down. This ensures that nodes which are not responding, for reasons such as hardware errors, are considered to be down.
  The time `T`, in which a node that is not responding is detected, is calculated as: `MinT < T < MaxT` where

      MinT = TickTime - TickTime / 4
      MaxT = TickTime + TickTime / 4

  `TickTime` is by default 60 (seconds). Thus, 45 < T < 75 seconds.
  Note:All communicating nodes should have the same `TickTime` value specified.
  Note: Normally, a terminating node is detected immediately.
`sync_nodes_mandatory = [NodeName] <optional>`
  Specifies which other nodes `must` be alive in order for this node to start properly. If some node in this list does not start within the specified time, this node will not start either. If this parameter is undefined, it defaults to the empty list.
`sync_nodes_optional = [NodeName] <optional>`
  Specifies which other nodes `can` be alive in order for this node to start properly. If some node in this list does not start within the specified time, this node starts anyway. If this parameter is undefined, it defaults to the empty list.
`sync_nodes_timeout = integer() | infinity <optional>`
  Specifies the amount of time (in milliseconds) this node will wait for the mandatory and optional nodes to start. If this parameter is undefined, no node synchronization is performed. This option also makes sure that global is synchronized.
`start_ddll = true | false <optional>`
  Starts the `ddll_server` if the parameter is `true` (see `erl_ddll(3)`). This parameter should be set to true in an embedded system which uses this service.
  The default value is `false`.
`start_dist_ac = true | false <optional>`
  Starts the `dist_ac` server if the parameter is `true` (see `application(3)`). This parameter should be set to true for systems that use distributed applications.
  The default value is `false`. If this parameter is undefined, the server is started if the parameter `distributed` is set.
`start_boot_server = true | false <optional>`
  Starts the `boot_server` if the parameter is `true` (see `erl_boot_server(3)`). This parameter should be set to true in an embedded system which uses this service.
  The default value is `false`.
`boot_server_slaves = [SlaveIP] <optional>`
  If the `start_boot_server` configuration parameter is `true`, this parameter can be used to initialize `boot_server` with a list of slave IP addresses. `SlaveIP = string() | atom | { integer(),integer(),integer(),integer()}`
  where `0 <= integer() <=255`.
  Examples of `SlaveIP` in atom, string and tuple form are:
  `'150.236.16.70', "150,236,16,70", {150,236,16,70}`.
  The default value is `[]`.
`start_disk_log = true | false <optional>`
  Starts the `disk_log_server` if the parameter is `true` (see `disk_log(3)`). This parameter should be set to true in an embedded system which uses this service.
  The default value is `false`.
`start_pg2 = true | false <optional>`
  Starts the `pg2` server (see `pg2(3)`) if the parameter is `true`. This parameter should be set to true in an embedded system which uses this service.
  The default value is `false`.
`start_timer = true | false <optional>`
  Starts the `timer_server` if the parameter is `true` (see `timer(3)`). This parameter should be set to true in an embedded system which uses this service.
  The default value is `false`.
`keep_zombies = integer() <optional>`
  Sets the value of the system flag `keep_zombies`.
  The default value is `0`.

### See Also

application(3), auth(3), code(3), disk_log(3), erl_ddll(3), erl_boot_server(3), error_logger(3), file(3), global(3), global_group(3), net_kernel(3), pg2(3), rpc(3), timer(3), user(3)

### AUTHORS

Martin Björklund - support@erlang.ericsson.se
Magnus Fröberg - support@erlang.ericsson.se

kernel 2.7.2
Copyright © 1991-2002 Ericsson Utvecklings AB